<?php

	define("MODULE_NAME","EventCalendar_1.0.0");
	define("TABLE_EVENTS",TABLE_PREFIX."mod_eventcalendar");
	
	define("BROWSE",0);
	define("CREATE_ITEM",6);
	define("ADD_ITEM",7);
	define("EDIT_ITEM",8);
	define("UPDATE_ITEM",9);
	define("DELETE_ITEM",10);

	class ModuleAdmin {		

		function BrowseEvents ()
			{
			global $IW;		
			$sql="select * from ".TABLE_EVENTS." order by event_date desc,event_time desc ";
			$result=$IW->DB_Query($sql);
			$matches=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			if(!isset($_REQUEST['prevoffset'])){$_REQUEST['prevoffset']=0;}
			if(!isset($_REQUEST['offset'])){$_REQUEST['offset']=0;}
			$sql .=" limit ".$_REQUEST['offset'].",10";		
			$result = $IW->DB_Query($sql);
			$IW->UI_OpenTable();
			echo "<tr>";
			echo "<td class=\"TableHeader\" colspan=\"2\">".$IW->UI_Label(MODA_0)."</td>";
			$AddItemAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$AddItemAction.="&modcmd=".CREATE_ITEM;
			$AddItemButton=MODA_1;
			$IW->UI_OpenForm("",$AddItemAction,"");
			echo "<td colspan=\"3\" class=\"TableHeader\" align=\"center\">".$IW->UI_Submit($AddItemButton)."</td>";
			$IW->UI_CloseForm();	
			echo "</tr>";
			$row=0;
			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				if($row==0){$class="TableRow1";}
				else{$class="TableRow2";}
				echo "<tr>";
				echo "<td class=\"".$class."\">".date(DATE_FORMAT,$IW->DB_Result($result,$i,"event_date"))."</td>";
				echo "<td class=\"".$class."\">".date(TIME_FORMAT,$IW->DB_Result($result,$i,"event_time"))."</td>";
				echo "<td class=\"".$class."\">".stripslashes($IW->DB_Result($result,$i,"event_title"))."</td>";
				$EditItemAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$EditItemAction.="&modcmd=".EDIT_ITEM."&id=".$IW->DB_Result($result,$i,"id");
				$EditItemButton=MODA_2;
				$IW->UI_OpenForm("",$EditItemAction,"");
				echo "<td class=\"".$class."\" align=\"center\" width=80>".$IW->UI_Submit($EditItemButton)."</td>";
				$IW->UI_CloseForm();				
				$DeleteItemAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$DeleteItemAction.="&modcmd=".DELETE_ITEM."&id=".$IW->DB_Result($result,$i,"id");
				$DeleteItemButton=MODA_3;
				$IW->UI_OpenForm("",$DeleteItemAction,"");
				echo "<td class=\"".$class."\" align=\"center\" width=80>".$IW->UI_Submit($DeleteItemButton)."</td>";
				$IW->UI_CloseForm();	
				if($row==0){$row=1;}
				else{$row=0;}
				}
			$IW->UI_CloseTable();
			$IW->DB_FreeResult($result);
			$IW->UI_OpenTable();
			echo "<tr>";
			if ($_REQUEST['offset']!=0) 
				{
				$PrevPageAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$PrevPageAction.="&offset=".($_REQUEST['offset']-3);
				$PrevPageButton=MODA_4;
				$IW->UI_OpenForm("",$PrevPageAction,"");
				echo "<td>".$IW->UI_Submit($PrevPageButton)."</td>";
				$IW->UI_CloseForm();	
				}
			$pages=intval($matches/10);
			if ($matches%10) {$pages++;}
			echo "<td>";
			for ($i=1;$i<=$pages;$i++) 
				{
				$newoffset=10*($i-1);
				$PageNumberLink=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$PageNumberLink.="&offset=".$newoffset;
				$PageNumberLinkTitle=$i;
				echo "<a href=\"".$PageNumberLink."\">".$PageNumberLinkTitle."</a> \n";
				}
			echo "</td>";
			if (!(($_REQUEST['offset']/10)==$pages) && $pages!=1) 
				{
				$newoffset=$_REQUEST['offset']+10;
				$NextPageAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$NextPageAction.="&offset=".$newoffset;
				$NextPageButton=MODA_5;
				$IW->UI_OpenForm("",$NextPageAction,"");
				echo "<td>".$IW->UI_Submit($NextPageButton)."</td>";
				$IW->UI_CloseForm();	
				}
			echo "</tr>";
			$IW->UI_CloseTable();
			}

	function EventForm ($mode,$id="")
		{
		global $IW;
		if($mode==1)
			{
			$FormTitle=MODA_6;
			$FormAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$FormAction.="&modcmd=".UPDATE_ITEM."&id=".$id;
			$FormButton=MODA_7;
			$result=$IW->DB_Query("select * from ".TABLE_EVENTS." where id='".$id."' limit 1");
			$date=date(DATE_FORMAT,$IW->DB_Result($result,0,"event_date"));
			$time=date(TIME_FORMAT,$IW->DB_Result($result,0,"event_time"));
			$title=stripslashes($IW->DB_Result($result,0,"event_title"));
			$description=stripslashes($IW->DB_Result($result,0,"event_description"));
			$IW->DB_FreeResult($result);
			}
		else
			{
			$FormTitle=MODA_8;
			$FormAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$FormAction.="&modcmd=".ADD_ITEM;
			$FormButton=MODA_9;
			$date=date(DATE_FORMAT);
			$time=date(TIME_FORMAT);
			$title="";
			$description="";
			}
		echo $IW->UI_Label($FormTitle);
		$IW->UI_OpenForm("",$FormAction,"");
		$IW->UI_OpenTable();
		echo "<tr><td>".$IW->UI_Label(MODA_10)."</td><td>".$IW->UI_TextBox("date",$date,15)."</td></tr>";
		echo "<tr><td>".$IW->UI_Label(MODA_10B)."</td><td>".$IW->UI_TextBox("time",$time,15)."</td></tr>";
		echo "<tr><td>".$IW->UI_Label(MODA_11)."</td><td>".$IW->UI_TextBox("title",$title,30)."</td></tr>";
		echo "<tr><td>".$IW->UI_Label(MODA_12)."</td><td>".$IW->UI_TextArea("description",$description,6,40)."</td></tr>";
		$IW->UI_CloseTable();
		echo $IW->UI_Submit($FormButton);
		$IW->UI_CloseForm();
		}

	function AddEvent ($category_id)
		{
		global $IW;
		$date=strtotime($_REQUEST['date']);
		$time=strtotime($_REQUEST['time']);
		$title=$IW->DB_ParseInput(addslashes($_REQUEST['title']));
		$description=$IW->DB_ParseInput(addslashes($_REQUEST['description']));
		$sql="insert into ".TABLE_EVENTS." (event_date,event_time,event_title,event_description) ";
		$sql.="values ('".$date."','".$time."','".$title."','".$description."')";
		echo $sql;
		$IW->DB_Query($sql);
		$IW->UI_Message(MODA_13);
		$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME);
		}

	function UpdateEvent ($id)
		{
		global $IW;
		$date=strtotime($_REQUEST['date']);
		$time=strtotime($_REQUEST['time']);
		$title=$IW->DB_ParseInput(addslashes($_REQUEST['title']));
		$description=$IW->DB_ParseInput(addslashes($_REQUEST['description']));
		$sql ="update ".TABLE_EVENTS." set ";
		$sql.="event_date='".$date."',";
		$sql.="event_time='".$time."',";
		$sql.="event_title='".$title."',";
		$sql.="event_description='".$description."' ";
		$sql.="where id='".$id."' limit 1";
		$IW->DB_Query($sql);
		$IW->UI_Message(MODA_14);
		$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME);
		}

	function DeleteEvent ($id)
		{
		global $IW;
		$result=$IW->DB_Query("delete from ".TABLE_EVENTS." where id='".$id."' limit 1");
		$IW->UI_Message(MODA_15);
		$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME);
		}

	// End Class
	}
	$Mod = new ModuleAdmin ();
	$IW->UI_OpenWidget(MODA_16);
	if(!isset($_REQUEST['modcmd'])){$_REQUEST['modcmd']=BROWSE;}
	switch($_REQUEST['modcmd'])
		{
		case BROWSE:
			$Mod->BrowseEvents ();
		break;
		case CREATE_ITEM:
			$Mod->EventForm(0);
		break;
		case ADD_ITEM:
			$Mod->AddEvent();
		break;
		case EDIT_ITEM:
			$Mod->EventForm(1,$_REQUEST['id']);
		break;
		case UPDATE_ITEM:
			$Mod->UpdateEvent($_REQUEST['id']);
		break;
		case DELETE_ITEM:
			$Mod->DeleteEvent($_REQUEST['id']);
		break;
		}

	$IW->UI_CloseWidget();
?>