<?php
	
	define("MODULE_NAME","Poll_1.0.0");	
	define("TABLE_QUESTIONS",TABLE_PREFIX."mod_poll");
	define("TABLE_LOG",TABLE_PREFIX."mod_poll_log");	
	define("POLL_DEFAULT",0);
	define("POLL_NEW",1);
	define("POLL_ADD",2);
	define("POLL_EDIT",3);
	define("POLL_UPDATE",4);
	define("POLL_DELETE",5);
	define("POLL_VIEW",6);

	class ModuleAdmin {

		function Poll_Manager ()
			{
			global $IW;
			$result=$IW->DB_Query("select * from ".TABLE_QUESTIONS." order by date_added desc");
			$count=$IW->DB_CountResult($result);
			$IW->UI_OpenTable();
			echo "<tr>\n";
			echo "<td class=\"TableHeader\">".MODA_1."</td>\n";
			echo "<td class=\"TableHeader\">".MODA_2."</td>\n";
			echo "<td class=\"TableHeader\" width=\"40\">".MODA_3."</td>\n";
			echo "<td class=\"TableHeader\" width=\"300\">".MODA_4."</td>\n";
			$action=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&modcmd=".POLL_NEW;
			$IW->UI_OpenForm('',$action,'');				
			echo "<td colspan=\"3\" class=\"TableHeader\">".$IW->UI_Submit(MODA_5)."</td>\n";
			$IW->UI_CloseForm();		
			echo "</tr>\n";			
			$row=0;			
			for($i=0;$i<$count;$i++)
				{
				if($row==0){$class="TableRow1";}
				else{$class="TableRow2";}
				echo "<tr>\n";
				echo "<td class=\"".$class."\">".date(DATE_FORMAT,$IW->DB_Result($result,$i,'date_added'))."</td>\n";
				echo "<td class=\"".$class."\">";
				if($this->Poll_Expired($IW->DB_Result($result,$i,'date_expire'))){echo MODA_6;}
				else{echo date(DATE_FORMAT,$IW->DB_Result($result,$i,'date_expire'));}
				echo "</td>\n";
				echo "<td class=\"".$class."\">".($IW->DB_Result($result,$i,'status')==1?MODA_7:MODA_8)."</td>\n";
				echo "<td class=\"".$class."\">".$IW->DB_Result($result,$i,'question')."</td>\n";
				$action=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$action.="&modcmd=".POLL_VIEW."&id=".$IW->DB_Result($result,$i,'id');
				$IW->UI_OpenForm('',$action,'');
				echo "<td class=\"".$class."\">".$IW->UI_Submit(MODA_9)."</td>\n";
				$IW->UI_CloseForm();
				$action=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$action.="&modcmd=".POLL_EDIT."&id=".$IW->DB_Result($result,$i,'id');
				$IW->UI_OpenForm('',$action,'');
				echo "<td class=\"".$class."\">".$IW->UI_Submit(MODA_10)."</td>\n";
				$IW->UI_CloseForm();
				$action=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$action.="&modcmd=".POLL_DELETE."&id=".$IW->DB_Result($result,$i,'id');
				$IW->UI_OpenForm('',$action,'');				
				echo "<td class=\"".$class."\">".$IW->UI_Submit(MODA_11)."</td>\n";
				$IW->UI_CloseForm();
				echo "</tr>\n";
				if($row==0){$row=1;}
				else{$row=0;}
				}
			$IW->UI_CloseTable();
			$IW->DB_FreeResult($result);
			}

		function Poll_Form ($mode,$id='')
			{
			global $IW;
			if($mode==1)
				{
				$FormTitle=MODA_12;
				$FormAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$FormAction.="&modcmd=".POLL_UPDATE."&id=".$id;
				$FormButton=MODA_13;
				$result=$IW->DB_Query("select * from ".TABLE_QUESTIONS." where id='".$id."' limit 1");
				$date_added=date(DATE_FORMAT,$IW->DB_Result($result,0,"date_added"));
				$date_expire=date(DATE_FORMAT,$IW->DB_Result($result,0,"date_expire"));
				$status=$IW->DB_Result($result,0,"status");
				$question=$IW->DB_Result($result,0,"question");			
				$option_0=$IW->DB_Result($result,0,"option_0");
				$option_1=$IW->DB_Result($result,0,"option_1");
				$option_2=$IW->DB_Result($result,0,"option_2");
				$option_3=$IW->DB_Result($result,0,"option_3");
				$option_4=$IW->DB_Result($result,0,"option_4");
				$IW->DB_FreeResult($result);
				}
			else
				{
				$FormTitle=MODA_14;
				$FormAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&modcmd=".POLL_ADD;
				$FormAction.="&modcmd=".POLL_ADD;
				$FormButton=MODA_15;
				$date_added=date(DATE_FORMAT);
				$date_expire=date(DATE_FORMAT,mktime (0,0,0,date("m")+1,date("d"),  date("Y")));
				$status=1;
				$question='';
				$option_0='';
				$option_1='';
				$option_2='';
				$option_3='';
				$option_4='';
				}
			echo $IW->UI_Label($FormTitle);
			$IW->UI_OpenForm("",$FormAction,"");
			$IW->UI_OpenTable(500);
			echo "<tr><td>".$IW->UI_Label(MODA_16)."</td><td>".$IW->UI_TextBox("date_added",$date_added,15)."</td></tr>";
			echo "<tr><td>".$IW->UI_Label(MODA_17)."</td><td>".$IW->UI_TextBox("date_expire",$date_expire,15)."</td></tr>";
			echo "<tr><td>".$IW->UI_Label(MODA_18)."</td><td>".$IW->UI_CheckBox('status','1',($status==1?1:0))."</td></tr>";
			echo "<tr><td>".$IW->UI_Label(MODA_19)."</td><td>".$IW->UI_TextArea("question",$question,5,50)."</td></tr>";
			for($i=0;$i<5;$i++)
				{
				echo "<tr>\n";
				echo "<td>".$IW->UI_Label(MODA_20.($i+1))."</td>\n";
				echo "<td>".$IW->UI_TextBox("option_".$i,${'option_'.$i},60)."</td>\n";
				echo "</tr>\n";
				}
			$IW->UI_CloseTable();
			echo $IW->UI_Submit($FormButton);
			$IW->UI_CloseForm();
			}

		function Poll_Add ()
			{
			global $IW;
			$date_added=strtotime($_REQUEST['date_added']);
			$date_expire=strtotime($_REQUEST['date_expire']);
			if(!isset($_REQUEST['status'])){$_REQUEST['status']==0;}
			$status=$_REQUEST['status'];
			$question=$IW->DB_ParseInput($_REQUEST['question']);
			$option_0=$IW->DB_ParseInput($_REQUEST['option_0']);
			$option_1=$IW->DB_ParseInput($_REQUEST['option_1']);
			$option_2=$IW->DB_ParseInput($_REQUEST['option_2']);
			$option_3=$IW->DB_ParseInput($_REQUEST['option_3']);
			$option_4=$IW->DB_ParseInput($_REQUEST['option_4']);
			$sql="insert into ".TABLE_QUESTIONS;
			$sql.=" (date_added,date_expire,status,question,option_0,option_1,option_2,option_3,option_4) ";
			$sql.="values ('".$date_added."','".$date_expire."','".$status."','".$question."',";
			$sql.="'".$option_0."','".$option_1."','".$option_2."','".$option_3."','".$option_4."')";
			$IW->DB_Query($sql);
			$IW->UI_Message(MODA_21);
			$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME);
			}

		function Poll_Update ($id)
			{
			global $IW;
			$date_added=strtotime($_REQUEST['date_added']);
			$date_expire=strtotime($_REQUEST['date_expire']);
			if(!isset($_REQUEST['status'])){$_REQUEST['status']==0;}
			$status=$_REQUEST['status'];
			$question=$IW->DB_ParseInput($_REQUEST['question']);
			$option_0=$IW->DB_ParseInput($_REQUEST['option_0']);
			$option_1=$IW->DB_ParseInput($_REQUEST['option_1']);
			$option_2=$IW->DB_ParseInput($_REQUEST['option_2']);
			$option_3=$IW->DB_ParseInput($_REQUEST['option_3']);
			$option_4=$IW->DB_ParseInput($_REQUEST['option_4']);
			$sql="update ".TABLE_QUESTIONS;
			$sql.=" set date_added='".$date_added."',date_expire='".$date_expire."',status='".$status."',question='".$question."',";
			$sql.="option_0='".$option_0."',option_1='".$option_1."',";
			$sql.="option_2='".$option_2."',option_3='".$option_3."',option_4='".$option_4."' where id='".$id."' limit 1";
			$IW->DB_Query($sql);
			$IW->UI_Message(MODA_22);
			$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME);
			}

		function Poll_Delete ($id)
			{
			global $IW;
			$sql="delete from ".TABLE_QUESTIONS." where id='".$id."' limit 1";
			$IW->DB_Query($sql);
			$sql="delete from ".TABLE_LOG." where poll_id='".$id."' ";
			$IW->DB_Query($sql);
			$IW->UI_Message(MODA_23);
			$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME);
			}

		function Poll_View ($id)
			{
			global $IW;
			$result=$IW->DB_Query("select * from ".TABLE_QUESTIONS." where id='".$id."' limit 1");
			$date_added=date(DATE_FORMAT,$IW->DB_Result($result,0,"date_added"));
			$date_expire=date(DATE_FORMAT,$IW->DB_Result($result,0,"date_expire"));
			$status=$IW->DB_Result($result,0,"status");
			$question=$IW->DB_Result($result,0,"question");			
			$option_0=$IW->DB_Result($result,0,"option_0");
			$option_1=$IW->DB_Result($result,0,"option_1");
			$option_2=$IW->DB_Result($result,0,"option_2");
			$option_3=$IW->DB_Result($result,0,"option_3");
			$option_4=$IW->DB_Result($result,0,"option_4");
			$score_0=$IW->DB_Result($result,0,"score_0");
			$score_1=$IW->DB_Result($result,0,"score_1");
			$score_2=$IW->DB_Result($result,0,"score_2");
			$score_3=$IW->DB_Result($result,0,"score_3");
			$score_4=$IW->DB_Result($result,0,"score_4");
			$IW->DB_FreeResult($result);
			$IW->UI_OpenTable(500);
			echo "<tr>\n<td colspan=\"3\" class=\"TableHeader\">".$question."</td>\n</tr>\n";
			$row=0;
			for($i=0;$i<5;$i++)
				{
				if(!empty(${'option_'.$i}))
					{
					if($row==0){$class="TableRow1";}
					else{$class="TableRow2";}
					echo "<tr>\n<td class=\"".$class."\">".${'option_'.$i}."</td><td  width=\"80\" class=\"".$class."\">".${'score_'.$i}." ".MODA_24."</td>\n<td width=\"80\" class=\"".$class."\">".$this->Poll_Score($id,$i)." %</td>\n</tr>\n";
					if($row==0){$row=1;}
					else{$row=0;}
					}	
				}
			$action=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$action.="&modcmd=".POLL_DEFAULT;
			$IW->UI_OpenForm('',$action,'');				
			echo "<tr>\n<td align=\"center\" colspan=\"3\">".$IW->UI_Submit(MODA_25)."</td>\n</tr>\n";
			$IW->UI_CloseForm();		
			$IW->UI_CloseTable();
			}

		function Poll_Expired ($date_expire)
			{
			if($date_expire < strtotime(date(DATE_FORMAT))){return TRUE;}
			else{return FALSE;}
			}

		function Poll_Score ($id,$option_no)
			{
			global $IW;
			$result=$IW->DB_Query("select * from ".TABLE_QUESTIONS." where id='".$id."' limit 1");		
			$option=$IW->DB_Result($result,0,"option_".$option_no);
			$score=$IW->DB_Result($result,0,"score_".$option_no);
			$option_0=$IW->DB_Result($result,0,"option_0");
			$option_1=$IW->DB_Result($result,0,"option_1");
			$option_2=$IW->DB_Result($result,0,"option_2");
			$option_3=$IW->DB_Result($result,0,"option_3");
			$option_4=$IW->DB_Result($result,0,"option_4");
			$score_0=$IW->DB_Result($result,0,"score_0");
			$score_1=$IW->DB_Result($result,0,"score_1");
			$score_2=$IW->DB_Result($result,0,"score_2");
			$score_3=$IW->DB_Result($result,0,"score_3");
			$score_4=$IW->DB_Result($result,0,"score_4");			
			$IW->DB_FreeResult($result);
			$total_score=0;
			if(!empty($option_0)){$total_score=($total_score+$score_0);}
			if(!empty($option_1)){$total_score=($total_score+$score_1);}
			if(!empty($option_2)){$total_score=($total_score+$score_2);}
			if(!empty($option_3)){$total_score=($total_score+$score_3);}
			if(!empty($option_4)){$total_score=($total_score+$score_4);}
			if($score<1)
				{return '0';}
			else
				{
				$percentage=round((($score / $total_score)*100),2);		
				return $percentage;
				}
			}

	// end class
	}

$Admin = new ModuleAdmin ();
$IW->UI_OpenWidget(MODA_0);
if(!isset($_REQUEST['modcmd'])){$_REQUEST['modcmd']=POLL_DEFAULT;}
switch($_REQUEST['modcmd'])
	{
	case POLL_DEFAULT:
		$Admin->Poll_Manager();
	break;
	case POLL_NEW:
		$Admin->Poll_Form(0);
	break;
	case POLL_ADD:
		$Admin->Poll_Add ();
	break;
	case POLL_EDIT:
		$Admin->Poll_Form(1,$_REQUEST['id']);
	break;
	case POLL_UPDATE:
		$Admin->Poll_Update($_REQUEST['id']);
	break;
	case POLL_DELETE:
		$Admin->Poll_Delete($_REQUEST['id']);
	break;
	case POLL_VIEW:
		$Admin->Poll_View($_REQUEST['id']);
	break;
	}
$IW->UI_CloseWidget();
?>