<?php
	
	define("MODULE_NAME","SysLogs_1.0.0");	
	define("TABLE_CONFIG",TABLE_PREFIX."mod_syslogs");	
	define("DIR_LOGS","logs/");	
	define("LOG_ACCESS","access.log");
	define("LOG_ERRORS","errors.log");
	define("SYSLOGS_INIT",0);
	define("SYSLOGS_UPDATE",1);
	define("SYSLOGS_VIEW",2);

	class ModuleAdmin {

		function Check_Reset ()
			{
			global $IW;
			$result=$IW->DB_Query("select * from ".TABLE_CONFIG." limit 1");
			$max_size=$IW->DB_Result($result,0,'max_size');
			$IW->DB_FreeResult($result);
			if(@filesize(DIR_LOGS.LOG_ACCESS)>$max_size)
				{
				$fp=@fopen(DIR_LOGS.LOG_ACCESS,'w');
				@fwrite($fp,'Log Flushed - '.date(DATE_FORMAT).' '.date(TIME_FORMAT));
				@fclose($fp);
				}
			if(@filesize(DIR_LOGS.LOG_ERRORS)>$max_size)
				{
				$fp=@fopen(DIR_LOGS.LOG_ERRORS,'w');
				@fwrite($fp,'Log Flushed - '.date(DATE_FORMAT).' '.date(TIME_FORMAT));
				@fclose($fp);
				}
			}

		function Config_Form ()
			{
			global $IW;
			$result=$IW->DB_Query("select * from ".TABLE_CONFIG." limit 1");
			$max_size=$IW->DB_Result($result,0,'max_size');
			$IW->DB_FreeResult($result);
			$action=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$action.="&modcmd=".SYSLOGS_UPDATE;
			$IW->UI_OpenForm('',$action,'');
			$IW->UI_OpenTable(350);
			echo "<tr>\n";
			echo "<td>".$IW->UI_Label(MODA_1)."</td>\n";
			echo "<td>".$IW->UI_TextBox('max_size',$max_size,10)." ".$IW->UI_Label(MODA_2)."</td>\n";
			echo "</tr>\n";
			echo "<tr>\n";
			echo "<td colspan=\"2\" align=\"center\">".$IW->UI_Submit(MODA_3)."</td>\n";
			echo "</tr>\n";
			$IW->UI_CloseTable ();
			$IW->UI_CloseForm();
			}

		function Config_Update ()
			{
			global $IW;
			$max_size=$IW->DB_ParseInput($_REQUEST['max_size']);
			if(empty($max_size)){$max_size=50;}
			$IW->DB_Query("update ".TABLE_CONFIG." set max_size='".$max_size."' limit 1");
			$IW->UI_Message(MODA_4);
			$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME);
			}

		function Logs_Form ()
			{
			global $IW;
			$action=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$action.="&modcmd=".SYSLOGS_VIEW;
			$IW->UI_OpenForm('',$action,'');
			$IW->UI_OpenTable(350);
			echo "<tr>\n";
			echo "<td align=\"center\">\n";
			$IW->UI_OpenListBox('log_file',5,0);
			if ($handle = @opendir(DIR_LOGS)) 
				{
				while (false !== ($file = @readdir($handle)))
					{
					if ($file != "." && $file != "..")
						{
						$filesize=@filesize(DIR_LOGS.$file);
						$IW->UI_ListOption($file,$file.' - '.$filesize.' bytes',1);
						}
					}
				@closedir($handle); 
				}			
			$IW->UI_CloseListBox();
			echo "</td>\n";
			echo "</tr>\n";
			echo "<tr>\n";
			echo "<td align=\"center\">".$IW->UI_Submit(MODA_5)."</td>\n";
			echo "</tr>\n";
			$IW->UI_CloseTable ();
			$IW->UI_CloseForm();
			}

		function Logs_View ()
			{
			global $IW;
			$log_file=$IW->DB_ParseInput($_REQUEST['log_file']);
			$handle = fopen (DIR_LOGS.$log_file, "r");
			$contents = fread ($handle, filesize (DIR_LOGS.$log_file));
			fclose ($handle);
			$records=explode("|",$contents);
			$action=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$IW->UI_OpenForm('',$action,'');
			$IW->UI_OpenTable(500);
			for($i=0;$i<count($records);$i++){echo "<tr>\n<td>\n".$records[$i]."</td></tr>\n\n";}
			echo "<tr>\n";
			echo "<td align=\"center\">".$IW->UI_Submit(MODA_6)."</td>\n";
			echo "</tr>\n";
			$IW->UI_CloseTable ();
			$IW->UI_CloseForm();
			}

	// end class
	}

	$Admin = new ModuleAdmin ();
	$IW->UI_OpenWidget(MODA_0);
	if(!isset($_REQUEST['modcmd'])){$_REQUEST['modcmd']=INIT;}
	switch($_REQUEST['modcmd'])
		{
		case SYSLOGS_INIT:
			$Admin->Check_Reset ();
			$Admin->Config_Form ();
			$Admin->Logs_Form ();
		break;
		case SYSLOGS_UPDATE:
			$Admin->Config_Update ();
		break;
		case SYSLOGS_VIEW:
			$Admin->Logs_View ();
		break;
		}
	$IW->UI_CloseWidget();
?>